const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const fulfillments = sequelize.define(
    'fulfillments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"success",


"cancelled",


"error"

        ],

      },

tracking_company: {
        type: DataTypes.TEXT,
      
      

      },

tracking_number: {
        type: DataTypes.TEXT,
      
      

      },

tracking_url: {
        type: DataTypes.TEXT,
      
      

      },

shipped_at: {
        type: DataTypes.DATE,
      
      

      },

delivered_at: {
        type: DataTypes.DATE,
      
      

      },

note: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  fulfillments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.fulfillments.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.fulfillments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.fulfillments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.fulfillments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return fulfillments;
};


